#ifndef MINLIB_ESP32_MUTEX_
#define MINLIB_ESP32_MUTEX_

#include "mnerror.hpp"

class basic_mutex {
public:
  basic_mutex();
  ~basic_mutex();

  int create();
	int lock();
	int unlock();

  bool try_lock();

  bool is_initialized() const 						{ return m_bisinitialized; }
private:
	void* m_pmutex;
	bool m_bisinitialized;
};

using mutext_t = basic_mutex;

template <class MUTEX = basic_mutex>
class  basic_autolock
{
public:
	basic_autolock(MUTEX &m) : m_ref_mutex(m) {
    m_ref_mutex.lock();
  }
	~basic_autolock() {
     m_ref_mutex.unlock();
   }
   operator bool() { return true; }
private:
	MUTEX &m_ref_mutex;
};

using autolock_t = basic_autolock<mutext_t>;


#endif
